VERSION 5.00
Object = "{6B7E6392-850A-101B-AFC0-4210102A8DA7}#1.2#0"; "COMCTL32.OCX"
Begin VB.Form frmFileAsoc 
   Caption         =   "File type association editor"
   ClientHeight    =   3765
   ClientLeft      =   1650
   ClientTop       =   1080
   ClientWidth     =   6450
   HelpContextID   =   100
   Icon            =   "frmFileAsoc.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   3765
   ScaleWidth      =   6450
   Begin VB.CommandButton cbEnumerate 
      Caption         =   "Resca&n the registry"
      Height          =   345
      Left            =   3645
      TabIndex        =   7
      ToolTipText     =   "Reloads the display from the registry"
      Top             =   615
      Width           =   1815
   End
   Begin VB.TextBox txtExtension 
      Height          =   315
      Left            =   1065
      TabIndex        =   1
      ToolTipText     =   "To create a new association type the extension into this box and use ""Edit"" or ""Associate with ExecTest"""
      Top             =   150
      Width           =   1215
   End
   Begin VB.TextBox txtClass 
      BackColor       =   &H8000000F&
      Height          =   315
      Left            =   3285
      Locked          =   -1  'True
      TabIndex        =   3
      Top             =   150
      Width           =   2175
   End
   Begin VB.CommandButton cbSave 
      Caption         =   "&Save changes"
      Enabled         =   0   'False
      Height          =   345
      Left            =   2080
      TabIndex        =   6
      ToolTipText     =   "Save the changes to the extension shown on the status bar"
      Top             =   615
      Width           =   1365
   End
   Begin VB.CommandButton cbEdit 
      Caption         =   "&Edit"
      Default         =   -1  'True
      Height          =   345
      Left            =   120
      TabIndex        =   4
      ToolTipText     =   "Edit the selected association"
      Top             =   615
      Width           =   735
   End
   Begin VB.CommandButton cbShow 
      Caption         =   "&Display"
      Height          =   345
      Left            =   1055
      TabIndex        =   5
      ToolTipText     =   "Show the selected association in a popup dialog"
      Top             =   615
      Width           =   825
   End
   Begin ComctlLib.StatusBar StatusBar 
      Align           =   2  'Align Bottom
      Height          =   315
      Left            =   0
      TabIndex        =   9
      Top             =   3450
      Width           =   6450
      _ExtentX        =   11377
      _ExtentY        =   556
      SimpleText      =   "Registry not scanned"
      _Version        =   327682
      BeginProperty Panels {0713E89E-850A-101B-AFC0-4210102A8DA7} 
         NumPanels       =   2
         BeginProperty Panel1 {0713E89F-850A-101B-AFC0-4210102A8DA7} 
            AutoSize        =   2
            Text            =   "Not scanned"
            TextSave        =   "Not scanned"
            Object.Tag             =   ""
            Object.ToolTipText     =   "Registry statistics"
         EndProperty
         BeginProperty Panel2 {0713E89F-850A-101B-AFC0-4210102A8DA7} 
            AutoSize        =   1
            Object.Width           =   8308
            Object.Tag             =   ""
            Object.ToolTipText     =   "The extension which will be saved or reloaded"
         EndProperty
      EndProperty
   End
   Begin ComctlLib.ListView lvFileTypes 
      Height          =   2385
      Left            =   15
      TabIndex        =   8
      Top             =   1080
      Width           =   6420
      _ExtentX        =   11324
      _ExtentY        =   4207
      View            =   3
      LabelEdit       =   1
      Sorted          =   -1  'True
      LabelWrap       =   -1  'True
      HideSelection   =   0   'False
      _Version        =   327682
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      BorderStyle     =   1
      Appearance      =   1
      NumItems        =   4
      BeginProperty ColumnHeader(1) {0713E8C7-850A-101B-AFC0-4210102A8DA7} 
         Key             =   ""
         Object.Tag             =   ""
         Text            =   "Extension"
         Object.Width           =   1587
      EndProperty
      BeginProperty ColumnHeader(2) {0713E8C7-850A-101B-AFC0-4210102A8DA7} 
         SubItemIndex    =   1
         Key             =   ""
         Object.Tag             =   ""
         Text            =   "File Class"
         Object.Width           =   2540
      EndProperty
      BeginProperty ColumnHeader(3) {0713E8C7-850A-101B-AFC0-4210102A8DA7} 
         SubItemIndex    =   2
         Key             =   ""
         Object.Tag             =   ""
         Text            =   "Description"
         Object.Width           =   2540
      EndProperty
      BeginProperty ColumnHeader(4) {0713E8C7-850A-101B-AFC0-4210102A8DA7} 
         SubItemIndex    =   3
         Key             =   ""
         Object.Tag             =   ""
         Text            =   "Action Verbs"
         Object.Width           =   3528
      EndProperty
   End
   Begin VB.Image IconFrame 
      Height          =   480
      Left            =   5760
      Top             =   300
      Width           =   480
   End
   Begin VB.Label Label1 
      Caption         =   "E&xtension"
      Height          =   255
      Left            =   180
      TabIndex        =   0
      Top             =   180
      Width           =   795
   End
   Begin VB.Label Label2 
      Caption         =   "File &Class"
      Height          =   255
      Left            =   2460
      TabIndex        =   2
      Top             =   180
      Width           =   675
   End
   Begin VB.Menu mnuMainFile 
      Caption         =   "&File"
      Begin VB.Menu mnuExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuMainAssociation 
      Caption         =   "&Association"
      HelpContextID   =   100
      Begin VB.Menu mnuEdit 
         Caption         =   "&Edit"
         HelpContextID   =   113
      End
      Begin VB.Menu mnuDisplay 
         Caption         =   "&Display"
         HelpContextID   =   114
      End
      Begin VB.Menu mnuExecTest 
         Caption         =   "&Associate with ExecTest"
         HelpContextID   =   115
      End
   End
   Begin VB.Menu mnuMainRegistry 
      Caption         =   "&Registry"
      HelpContextID   =   110
      Begin VB.Menu mnuSave 
         Caption         =   "&Save changed extension"
         Enabled         =   0   'False
         HelpContextID   =   112
      End
      Begin VB.Menu mnuRescan 
         Caption         =   "&Rescan"
      End
   End
   Begin VB.Menu mnuMainHelp 
      Caption         =   "&Help"
      Begin VB.Menu mnuAbout 
         Caption         =   "&About FileAsoc"
      End
      Begin VB.Menu mnuContents 
         Caption         =   "&Contents"
      End
      Begin VB.Menu mnuMainWindow 
         Caption         =   "&This dialog"
         HelpContextID   =   100
      End
      Begin VB.Menu mnuHowOpen 
         Caption         =   "&How Windows opens files"
         HelpContextID   =   50
      End
      Begin VB.Menu mnuSeparator 
         Caption         =   "-"
      End
      Begin VB.Menu mnuWebSite 
         Caption         =   "Visit our &Web site"
      End
   End
   Begin VB.Menu mnuPopup 
      Caption         =   "Popup"
      Visible         =   0   'False
      Begin VB.Menu mnuEditPopup 
         Caption         =   "&Edit"
         HelpContextID   =   113
      End
      Begin VB.Menu mnuDisplayPopup 
         Caption         =   "&Display"
         HelpContextID   =   114
      End
      Begin VB.Menu mnuExecTestPopup 
         Caption         =   "&Associate with ExecTest"
         HelpContextID   =   115
      End
   End
End
Attribute VB_Name = "frmFileAsoc"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim Association As FileAssociation

'Variables to control when things need saving and loading
Dim LastSelection As Long
Dim AssociationLoaded As Boolean
Dim AssociationEdited As Boolean

Dim WidthAdjustment As Long
Dim HeightAdjustment As Long

'The text which goes to the popup text display
Dim DisplayText As String

Private Declare Function WinHelp Lib "user32" Alias "WinHelpA" (ByVal hwnd As Long, ByVal lpHelpFile As String, ByVal wCommand As Long, ByVal dwData As Long) As Long
Private Const HELP_CONTEXT = &H1&
Private Const HELP_CONTENTS = &H3&
Private Const HELP_CONTEXTPOPUP = &H8&
Private Const HELP_FINDER = &HB&

'Declarations for changing the ListView appearance

Private Const LVM_FIRST = &H1000&
Private Const LVM_SETEXTENDEDLISTVIEWSTYLE = (LVM_FIRST + 54)
Private Const LVM_GETEXTENDEDLISTVIEWSTYLE = (LVM_FIRST + 55)

Private Const LVS_EX_GRIDLINES = &H1&
Private Const LVS_EX_SUBITEMIMAGES = &H2&
Private Const LVS_EX_CHECKBOXES = &H4&
Private Const LVS_EX_TRACKSELECT = &H8&
Private Const LVS_EX_HEADERDRAGDROP = &H10&
Private Const LVS_EX_FULLROWSELECT = &H20&
Private Const LVS_EX_ONECLICKACTIVATE = &H40&
Private Const LVS_EX_TWOCLICKACTIVATE = &H80&
Private Const LVS_EX_FLATSB = &H100
Private Const LVS_EX_REGIONAL = &H200
Private Const LVS_EX_INFOTIP = &H400&
Private Const LVS_EX_UNDERLINEHOT = &H800

Private Declare Function ExtractIcon Lib "shell32.dll" Alias "ExtractIconA" (ByVal hInst As Long, ByVal lpszExeFileName As String, ByVal nIconIndex As Long) As Long
Private Declare Function CreateWindowEx Lib "user32" Alias "CreateWindowExA" (ByVal dwExStyle As Long, ByVal lpClassName As String, ByVal lpWindowName As String, ByVal dwStyle As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hWndParent As Long, ByVal hMenu As Long, ByVal hInstance As Long, lpParam As Any) As Long
Private Declare Function DrawIcon Lib "user32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal hIcon As Long) As Long

Public hIcon As Long
Public hwndIcon As Long
Public bStartup As Boolean
Private ProgChange As Boolean
'
'Load the file association from the extension in the combo box or the class name if absent,
'unless it has been done already.
'Return false only if the extension is not valid, the FileAssociation
'class makes defaults in other cases of missing info.
'
Private Function LoadAssociation(ByVal ShowErrors As Boolean, ByVal QuerySave As Boolean) As Boolean

Dim Res As LoadAssociationResult
Dim lExtension As String

'Don't re-load if done already
If AssociationLoaded Then
  LoadAssociation = True
  Exit Function
End If

If QuerySave Then Call QuerySaveAssociation

'Check for the special cases
lExtension = Association.GoodExtension(txtExtension.Text)

'Check that an extension has been given, if not load the class only
If Len(lExtension) = 0 Then
    Association.Extension = ""
    If Not Association.FileClass.LoadFromRegistry(txtClass.Text) Then
        If ShowErrors Then MsgBox Association.FileClass.LastError
        LoadAssociation = False
      Else
        AssociationLoaded = True
        LoadAssociation = True
      End If
    Exit Function
End If

Res = Association.LoadFromRegistry(lExtension)

Select Case Res
  Case LOAD_ASOC_SUCCESS
    AssociationLoaded = True
    LoadAssociation = True
  Case LOAD_ASOC_NO_SHELL_COMMANDS
    AssociationLoaded = True
    LoadAssociation = True
Case Else
    If ShowErrors Then MsgBox Association.LastError
    LoadAssociation = False
End Select

End Function
'
'Edit the association. If not registered, leave the details as they are
'
Private Sub cbEdit_Click()

'Any old rubbish can be edited
Call LoadAssociation(False, True)

Load frmEditAssociation
Call frmEditAssociation.SetMembers(Association)
frmEditAssociation.Show vbModal

If frmEditAssociation.ChangesMade Then
    SetEditedStatus (" " & StrConv(txtExtension.Text, vbUpperCase) & " CHANGED ")
End If

Unload frmEditAssociation

ProgChange = True
txtExtension.Text = Association.Extension
txtClass.Text = Association.FileClass.ClassName
Call ShowClassIcon(Association.FileClass)
ProgChange = False

'We carry on with whatever the user typed
AssociationLoaded = True
End Sub
Public Sub cbEnumerate_Click()

Dim ExtensionCount As Long
Dim ClassCount As Long

'This may take a while
MousePointer = vbHourglass
StatusBar.Panels(1).Text = " Scanning the Registry ... "
Me.Refresh

ExtensionCount = FillListView(lvFileTypes, ClassCount)

StatusBar.Panels(1).Text = " " & CStr(ExtensionCount) & " extensions, " & CStr(ClassCount) & " classes, " & _
    CStr(lvFileTypes.ListItems.Count) & " items "
MousePointer = vbDefault

End Sub
Private Sub ShowClassIcon(lClass As FileClass)

hIcon = GetClassIcon(lClass)
Call SendMessage(hwndIcon, STM_SETICON, hIcon, 0)

End Sub
Private Function GetClassIcon(lClass As FileClass) As Long

Dim lVerb As ExecVerb

'Default to no icon
GetClassIcon = 0
    
If lClass.DefaultIconFile <> "" Then
    GetClassIcon = GetIcon(lClass.DefaultIconFile, lClass.IconIndex)
ElseIf lClass.DefaultVerb <> "" Then
    Set lVerb = lClass.Verb(StrConv(lClass.DefaultVerb, vbLowerCase))
    If lVerb Is Nothing Then
        If lClass.VerbCount <> 0 Then
            Set lVerb = lClass.Verb(1)
        End If
    End If
    If lVerb Is Nothing Then
        MsgBox "There are no verbs"
    Else
        GetClassIcon = GetIconFromCommand(lVerb.Command)
    End If
ElseIf lClass.VerbCount <> 0 Then
    On Error GoTo NoOpen
    Set lVerb = lClass.Verb("open")
    On Error GoTo 0
    If lVerb Is Nothing Then
        Set lVerb = lClass.Verb(1)
    End If
    If Not lVerb Is Nothing Then
        GetClassIcon = GetIconFromCommand(lVerb.Command)
    End If
NoOpen:
End If

End Function
Private Sub ShowExtensionStatus()

Dim TestAssociation As FileAssociation

Set TestAssociation = New FileAssociation

'Clear the icon in case there is none
hIcon = 0
Call SendMessage(hwndIcon, STM_SETICON, hIcon, 0)

If TestAssociation.LoadFromRegistry(txtExtension.Text) = LOAD_ASOC_SUCCESS Then
    Call ShowClassIcon(TestAssociation.FileClass)
End If

End Sub
Private Function GetIcon(ByVal FileName As String, ByVal Index As Long) As Long

Dim lhIcon As Long

lhIcon = 0

If FileName <> "" Then
    lhIcon = ExtractIcon(App.hInstance, FileName, Index)
    If lhIcon <= 2 Then lhIcon = 0
End If

GetIcon = lhIcon

End Function
Private Function GetIconFromCommand(ByVal CmdLine As String) As Long

Dim Pos As Long

'Attempt to extract the file name from the command line
If Left$(CmdLine, 1) = """" Then
    CmdLine = Right$(CmdLine, Len(CmdLine) - 1)
    Pos = InStr(CmdLine, """")
    If Pos > 1 Then
        CmdLine = Left$(CmdLine, Pos - 1)
    End If
Else
    Pos = InStr(CmdLine, " -")
    If Pos > 1 Then CmdLine = Left$(CmdLine, Pos - 1)
    Pos = InStr(CmdLine, " %")
    If Pos > 1 Then CmdLine = Left$(CmdLine, Pos - 1)
    Pos = InStr(CmdLine, " ""%")
    If Pos > 1 Then CmdLine = Left$(CmdLine, Pos - 1)
    Pos = InStr(CmdLine, " /")
    If Pos > 1 Then
        CmdLine = Left$(CmdLine, Pos - 1)
    End If
End If

GetIconFromCommand = GetIcon(CmdLine, 0)

End Function
Private Sub cbSave_Click()

Dim Res As VbMsgBoxResult

If OriginalString(Association.Extension) = "" Then
  Res = MsgBox("Confirm overwrite the registry for """ & Association.FileClass.ClassName & """", vbYesNo)
Else
  Res = MsgBox("Confirm overwrite the registry for """ & Association.Extension & """", vbYesNo)
End If

If Res = vbYes Then
  If Not Association.SaveToRegistry Then
    MsgBox Association.LastError
  End If
Else
    Call ShowExtensionStatus
End If

SetEditedStatus ("")

End Sub
Private Sub SetEditedStatus(ByVal ChangedExt As String)

StatusBar.Panels(2).Text = ChangedExt

If ChangedExt = "" Then
    mnuSave.Enabled = False
    cbSave.Enabled = False
    AssociationEdited = False
Else
    mnuSave.Enabled = True
    cbSave.Enabled = True
    AssociationEdited = True
End If

End Sub
Private Sub lvFileTypes_ColumnClick(ByVal ColumnHeader As ComctlLib.ColumnHeader)
  If lvFileTypes.ListItems.Count = 0 Then Exit Sub
  lvFileTypes.SortKey = ColumnHeader.Index - 1
  
  If Not lvFileTypes.SelectedItem Is Nothing Then
    Call lvFileTypes.SelectedItem.EnsureVisible
End If

End Sub
Private Sub lvFileTypes_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
  If Button <> vbRightButton Or lvFileTypes.SelectedItem Is Nothing Then Exit Sub
  PopupMenu mnuPopup
End Sub

Private Sub mnuHowOpen_Click()
  Call WinHelp(Me.hwnd, App.Path & "\FileAsoc.hlp", HELP_CONTEXT, 50)
End Sub
Private Sub mnuMainWindow_Click()
  Call WinHelp(Me.hwnd, App.Path & "\FileAsoc.hlp", HELP_CONTEXT, 100)
End Sub
Private Sub mnuSave_Click()
  Call cbSave_Click
End Sub
'
'If the edit box of the combo is changed the extension needs reloading
'
Private Sub txtExtension_Change()

Dim lvItem As ListItem

If ProgChange Then Exit Sub

Set lvItem = lvFileTypes.FindItem(Association.GoodExtension(txtExtension.Text))

If Not lvItem Is Nothing Then
    Set lvFileTypes.SelectedItem = lvItem
    Call lvItem.EnsureVisible
End If

Call ShowExtensionStatus
AssociationLoaded = False

End Sub
'
'Show the current association in the text box
'
Private Sub cbShow_Click()

If Not LoadAssociation(True, True) Then Exit Sub

DisplayText = vbCrLf & Association.Enumerate
Load frmShowText
frmShowText.lblCaption.Caption = "File associations for extension " & DisplayString(Association.Extension)

If Association.FileClass.VerbCount = 1 Then
  frmShowText.StatusBar.Panels(1).Text = " 1 Action Verb "
Else
  frmShowText.StatusBar.Panels(1).Text = " " & CStr(Association.FileClass.VerbCount) & " Action Verbs "
End If

frmShowText.Text = DisplayText
frmShowText.Show vbModal
Unload frmShowText

End Sub
Private Sub Form_Load()

Set Association = New FileAssociation

'The statement below looks absolutely stupid, but if you don't do it,
'setting the listview to full row select does not work !!!
lvFileTypes.ColumnHeaders(1).Width = lvFileTypes.ColumnHeaders(1).Width
Call SetListviewExtendedStyle(LVS_EX_FULLROWSELECT)

'Note the adjustments for the main text box
MinWidth = Me.Width \ Screen.TwipsPerPixelX
MinHeight = Me.Height \ Screen.TwipsPerPixelY

IconFrame.Width = 32 * Screen.TwipsPerPixelX
IconFrame.Height = 32 * Screen.TwipsPerPixelY

WidthAdjustment = Me.Width - lvFileTypes.Width
HeightAdjustment = Me.Height - lvFileTypes.Height
StatusBar.Panels(1).Text = " Scanning the Registry ... "

hwndIcon = CreateWindowEx(WS_EX_NOPARENTNOTIFY, "STATIC", "Test", WS_CHILD Or WS_VISIBLE Or SS_ICON, _
        IconFrame.Left / Screen.TwipsPerPixelX, IconFrame.Top / Screen.TwipsPerPixelY, 32, 32, Me.hwnd, 0, App.hInstance, 0)
 
Call SubClass(Me.hwnd)

'Show the splash screen modally, otherwise it gets covered up
bStartup = True
frmFileAsocAbout.Show vbModal
bStartup = False

ProgChange = True
AssociationLoaded = LoadAssociation(False, True)
ProgChange = False

End Sub
Private Sub Form_Resize()

If Me.WindowState <> vbMinimized Then
  'Adjust the size of the main text area
  lvFileTypes.Height = Me.Height - HeightAdjustment
  lvFileTypes.Width = Me.Width - WidthAdjustment
End If

End Sub
Private Sub Form_Unload(Cancel As Integer)

Call QuerySaveAssociation
Call UnSubClass(Me.hwnd)
Set Association = Nothing

End Sub
Private Sub QuerySaveAssociation()

If AssociationEdited Then
  If OriginalString(Association.Extension) = "" Then
    If MsgBox("Do you want to save your changes to file class """ & Association.FileClass.ClassName & """", vbYesNo) = vbYes Then
        Call cbSave_Click
    End If
  Else
    If MsgBox("Do you want to save your changes to extension """ & Association.Extension & """", vbYesNo) = vbYes Then
        Call cbSave_Click
    End If
  End If
End If

SetEditedStatus ("")

End Sub
Private Sub lvFileTypes_DblClick()
Call SelectFromListView
End Sub
Private Sub lvFileTypes_ItemClick(ByVal Item As ComctlLib.ListItem)
Call SelectFromListView
End Sub
Private Sub SelectFromListView()

'If the End key or page down is used there may not be a selected item
On Error GoTo NoSelection

'Be careful not to change anything if the selection has not in fact changed
If LastSelection = lvFileTypes.SelectedItem.Index Then Exit Sub
LastSelection = lvFileTypes.SelectedItem.Index

ProgChange = True
txtExtension.Text = lvFileTypes.SelectedItem.Text
txtClass.Text = lvFileTypes.SelectedItem.SubItems(1)
Call ShowExtensionStatus
AssociationLoaded = False
ProgChange = False

NoSelection:
End Sub
Private Sub lvFileTypes_KeyPress(KeyAscii As Integer)
If KeyAscii = vbEnter Then Call SelectFromListView
End Sub
Private Sub mnuAbout_Click()
    frmFileAsocAbout.Show vbModal
End Sub
Public Sub mnuContents_Click()
  Call WinHelp(Me.hwnd, App.Path & "\FileAsoc.hlp", HELP_FINDER, 0)
End Sub
Private Sub mnuDisplay_Click()
    Call cbShow_Click
End Sub
Private Sub mnuDisplayPopup_Click()
    Call cbShow_Click
End Sub
Private Sub mnuEdit_Click()
    Call cbEdit_Click
End Sub
Private Sub mnuEditPopup_Click()
    Call cbEdit_Click
End Sub
Private Sub mnuExecTest_Click()
    
Dim lVerb As ExecVerb
Dim StrippedExtension As String
Dim TestAssociation As FileAssociation
Dim lFileClass As FileClass
Dim Res As LoadAssociationResult
Dim FileName As String
Dim FileNo As Long

'Check that the extension is valid
Set TestAssociation = New FileAssociation
Res = TestAssociation.LoadFromRegistry(txtExtension.Text)

Select Case Res
Case LOAD_ASOC_INVALID_PARAMETER
  MsgBox "The file extension is not valid"
  Exit Sub
Case LOAD_ASOC_NOT_REGISTERED
  GoTo DoAssociation
Case Else
  If MsgBox("The extension """ & TestAssociation.Extension & """ is already registered. " & _
    "Do you wish to proceed?", vbYesNo) <> vbYes Then Exit Sub
End Select

DoAssociation:

'We are proceeding, continue with the new association
Set Association = TestAssociation
Set lFileClass = Association.FileClass

StrippedExtension = Right$(Association.Extension, Len(Association.Extension) - 1)

'Fill in any blank elements
If lFileClass.ClassName = "" Then
    lFileClass.ClassName = StrippedExtension & "file"
End If

If lFileClass.Description = "" Then
    lFileClass.Description = "ExecTest extension " & StrippedExtension
End If

'Get the open verb if it exists, else create it
Set lVerb = lFileClass.Verb("open")
If lVerb Is Nothing Then
  Call lFileClass.AddVerb("Open")
  Set lVerb = lFileClass.Verb("open")
  If lVerb Is Nothing Then
    MsgBox "Cannot open or create the ""Open"" verb for file extension """ & Association.Extension & """"
    Exit Sub
  End If
End If

lVerb.Command = App.Path & "\ExecTest.exe" & " ""%1"" /Open"
lVerb.Ddeexec = "[open(""%1"")]"
lVerb.IfExecDde = "[open app started(""%1"")]"
lVerb.Application = "ExecTest"
lVerb.Topic = "System"
    
'Get the "New verb"  verb if it exists, else create it
Set lVerb = lFileClass.Verb("New verb")
If lVerb Is Nothing Then
  Call lFileClass.AddVerb("New verb")
  Set lVerb = lFileClass.Verb("New verb")
  If lVerb Is Nothing Then
    MsgBox "Cannot open or create ""New verb"" for extension """ & Association.Extension & """"
    Exit Sub
  End If
End If

lVerb.Command = App.Path & "\ExecTest.exe" & " ""%1"" /NewVerb"
lVerb.Ddeexec = "[NewVerb(""%1"")]"
lVerb.IfExecDde = "[NewVerb app started(""%1"")]"
lVerb.Application = "ExecTest"
lVerb.Topic = "System"
    
Load frmEditAssociation
Call frmEditAssociation.SetMembers(Association)
frmEditAssociation.Show vbModal
Unload frmEditAssociation

ProgChange = True
txtExtension.Text = Association.Extension
txtClass.Text = Association.FileClass.ClassName
ProgChange = False

'We carry on with whatever the user typed
AssociationLoaded = True
SetEditedStatus (" " & StrConv(txtExtension.Text, vbUpperCase) & " CHANGED ")

'Now make a test file, unless one exists
FileName = Dir(App.Path & "\ExecTest" & Association.Extension)
If FileName = "" Then
  FileNo = FreeFile()
  Open App.Path & "\ExecTest" & Association.Extension For Output As #FileNo
  Print #FileNo, "ExecTest example file"
  Close #FileNo
End If

End Sub
Private Sub mnuExecTestPopup_Click()
 Call mnuExecTest_Click
End Sub
Private Sub mnuExit_Click()
 Unload Me
End Sub
Private Sub mnuRescan_Click()
    Call cbEnumerate_Click
End Sub
Private Sub SetListviewExtendedStyle(Style As Long)
Call SendMessage(lvFileTypes.hwnd, LVM_SETEXTENDEDLISTVIEWSTYLE, Style, Style)
Call lvFileTypes.Refresh
End Sub
Private Sub ClearListviewExtendedStyle(Style As Long)
Call SendMessage(lvFileTypes.hwnd, LVM_SETEXTENDEDLISTVIEWSTYLE, Style, 0)
Call lvFileTypes.Refresh
End Sub
Public Sub mnuWebSite_Click()
  Call frmFileAsocAbout.VisitWebSite
End Sub
'
'Enumerate the extensions to a ListView. 'The return value is the number of extensions. The total number
'of entries including "orphan" File Classes can be found from the count of list items
'
Public Function FillListView(lvTypes As ListView, ByRef ClassCount As Long) As Long

Dim NextExtension As String
Dim KeyIndex As Integer
Dim Res As Long
Dim lCount As Long
Dim lvItem As ListItem

Dim lClassName As String
Dim lDefaultVerb As String
Dim ClassKey As Variant
Dim FileClasses As Collection

Call lvTypes.ListItems.Clear
Set lvTypes.Icons = Nothing
Set lvTypes.SmallIcons = Nothing

Set FileClasses = New Collection

'First pass, find all keys starting with a dot and collect the class names

KeyIndex = 0
lCount = 0

Do
  NextExtension = String(100, Chr$(0))
  Res = RegEnumKey(modRegistry.HKEY_CLASSES_ROOT, KeyIndex, NextExtension, Len(NextExtension))
  If Res <> ERROR_SUCCESS Then
     Exit Do
  End If

  'Look for keys which start with a dot
  If Left$(NextExtension, 1) = "." Then
    NextExtension = VBstring(NextExtension)
    
    'Read and store the file class
    If RegReadDefaultStringValue(HKEY_CLASSES_ROOT, NextExtension, lClassName) = ERROR_SUCCESS Then
      If lClassName <> "" Then
        ClassKey = StrConv(lClassName, vbLowerCase)
        'Add the Class name if not there already
        On Error Resume Next
        Call FileClasses.Add(lClassName, ClassKey)
        On Error GoTo 0
      End If
    End If
    
    'Add the extension and class to the ListView. The Class may not exist.
    Set lvItem = lvTypes.ListItems.Add(, , NextExtension)
    Call SetDescriptionAndVerbs(lClassName, lvItem)
    lvItem.SubItems(1) = DisplayString(lClassName)
    
  End If
  
  KeyIndex = KeyIndex + 1
Loop

'The return value is the number of extensions. Count classes so far
FillListView = lvTypes.ListItems.Count
lCount = FileClasses.Count

'Go through the registry again, filling the ListView with any classes which have shell
'commands but are not used by a file extension

KeyIndex = 0
Do
  lClassName = String(100, Chr$(0))
  Res = RegEnumKey(modRegistry.HKEY_CLASSES_ROOT, KeyIndex, lClassName, Len(lClassName))
  If Res <> ERROR_SUCCESS Then
     Exit Do
  End If

  'Look for keys which do not start with a dot
  If Left$(lClassName, 1) <> "." Then
    lClassName = VBstring(lClassName)
    
    'Read the default shell key
    If RegReadDefaultStringValue(HKEY_CLASSES_ROOT, lClassName & "\shell", lDefaultVerb) = ERROR_SUCCESS Then
        ClassKey = StrConv(lClassName, vbLowerCase)
        On Error GoTo NoExtensionLink
        lDefaultVerb = FileClasses(ClassKey)
        'No error, an extension pointing at the class exist
HasExtensionLink:
        On Error GoTo 0
    End If
 End If
 
KeyIndex = KeyIndex + 1
Loop

ExitFill:
Set lvTypes.SelectedItem = lvTypes.ListItems(1)
LastSelection = -1
Call SelectFromListView
ClassCount = lCount

Exit Function

NoExtensionLink:
  'Add the extension and class to the ListView
  Set lvItem = lvTypes.ListItems.Add(, , EMPTY_STRING)
  lvItem.SubItems(1) = lClassName
  Call SetDescriptionAndVerbs(lClassName, lvItem)
  lCount = lCount + 1
  Resume HasExtensionLink
End Function
Private Sub SetDescriptionAndVerbs(lClassName As String, lvItem As ListItem)

Dim lFileClass As FileClass
Dim DefVerb As ExecVerb

Set lFileClass = New FileClass
    
    If lFileClass.LoadFromRegistry(lClassName) Then
        lvItem.SubItems(2) = lFileClass.Description
        
        If lFileClass.VerbCount <> 0 Then
            Dim strVerbs As String
            Dim lVerb As ExecVerb
            
            strVerbs = ""
            For Each lVerb In lFileClass
                strVerbs = strVerbs & lVerb.Verb & ", "
            Next
            strVerbs = Left$(strVerbs, Len(strVerbs) - 2)
            lvItem.SubItems(3) = strVerbs
            
        End If
    End If

End Sub

