VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.1#0"; "COMDLG32.OCX"
Begin VB.Form frmEditAssociation 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Edit file association"
   ClientHeight    =   6240
   ClientLeft      =   5475
   ClientTop       =   2355
   ClientWidth     =   5415
   HelpContextID   =   101
   Icon            =   "frmEditAssociation.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   6240
   ScaleWidth      =   5415
   Begin VB.Frame Frame1 
      Caption         =   "De&fault Icon. Type, Browse or Drag and Drop the file name"
      Height          =   1185
      Left            =   60
      TabIndex        =   6
      Top             =   945
      Width           =   5295
      Begin VB.CommandButton cbShow 
         Caption         =   "Next &Icon"
         Height          =   330
         Left            =   4005
         TabIndex        =   11
         ToolTipText     =   "Click to move to the next icon in the file"
         Top             =   720
         Width           =   1140
      End
      Begin VB.TextBox txtIndex 
         Height          =   285
         Left            =   3195
         TabIndex        =   10
         ToolTipText     =   "The index of the icon on view"
         Top             =   750
         Width           =   690
      End
      Begin VB.TextBox txtFile 
         Height          =   315
         Left            =   180
         OLEDropMode     =   1  'Manual
         TabIndex        =   7
         ToolTipText     =   "Type or Drag and Drop the file containing icons. BMP, ICO, CUR and ANI files or any executable (EXE, DLL, OCX etc)"
         Top             =   323
         Width           =   4605
      End
      Begin VB.CommandButton cbBrowseIcon 
         Caption         =   "..."
         BeginProperty Font 
            Name            =   "System"
            Size            =   9.75
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   315
         Left            =   4770
         TabIndex        =   8
         ToolTipText     =   "Browse for the file containing the icon"
         Top             =   323
         Width           =   375
      End
      Begin VB.Label lblIconCount 
         Caption         =   "No icons"
         Height          =   240
         Left            =   225
         TabIndex        =   30
         Top             =   765
         Width           =   825
      End
      Begin VB.Label Label2 
         Caption         =   "Icon i&ndex"
         Height          =   240
         Left            =   2295
         TabIndex        =   9
         Top             =   765
         Width           =   825
      End
   End
   Begin VB.Frame frameCommands 
      Caption         =   "Commands for selected verb"
      Height          =   2715
      Left            =   60
      TabIndex        =   29
      Top             =   2985
      Width           =   5295
      Begin VB.CommandButton cbBrowse 
         Caption         =   "..."
         BeginProperty Font 
            Name            =   "System"
            Size            =   9.75
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   315
         Left            =   4800
         TabIndex        =   19
         ToolTipText     =   "Browse for the application to associate with the file for the selected Action Verb"
         Top             =   600
         Width           =   375
      End
      Begin VB.TextBox txtDDEOnStarting 
         Height          =   315
         Left            =   180
         TabIndex        =   23
         ToolTipText     =   "If the application had to be started and thiis field is not blank, the DDE command is used instead"
         Top             =   1860
         Width           =   4995
      End
      Begin VB.TextBox txtCommandLine 
         Height          =   315
         Left            =   195
         OLEDropMode     =   1  'Manual
         TabIndex        =   18
         ToolTipText     =   "The name of the program to run followed by the command line parameters"
         Top             =   600
         Width           =   4635
      End
      Begin VB.TextBox txtService 
         Height          =   315
         Left            =   1440
         TabIndex        =   25
         ToolTipText     =   "The name of the DDE Service the shell connects to in sending DDE commands"
         Top             =   2280
         Width           =   1215
      End
      Begin VB.TextBox txtTopic 
         Height          =   315
         Left            =   3300
         TabIndex        =   27
         ToolTipText     =   "The name of the Topic the shell uses in sending DDE commands (usually ""System"")"
         Top             =   2280
         Width           =   1875
      End
      Begin VB.TextBox txtDDECommand 
         Height          =   315
         Left            =   180
         TabIndex        =   21
         ToolTipText     =   "The default DDE execute command sent to the application"
         Top             =   1185
         Width           =   4995
      End
      Begin VB.Label Label1 
         Caption         =   "DD&E command when application is started (defaults to above)"
         Height          =   195
         Left            =   180
         TabIndex        =   22
         Top             =   1620
         Width           =   4875
      End
      Begin VB.Label Label3 
         Caption         =   "Command line to &start application. Type, Browse or Drag and Drop"
         Height          =   255
         Left            =   180
         TabIndex        =   17
         Top             =   300
         Width           =   4830
      End
      Begin VB.Label Label4 
         Caption         =   "DDE A&pplication"
         Height          =   255
         Left            =   180
         TabIndex        =   24
         Top             =   2310
         Width           =   1275
      End
      Begin VB.Label Label5 
         Caption         =   "&DDE command when application is already running"
         Height          =   255
         Left            =   180
         TabIndex        =   20
         Top             =   945
         Width           =   4875
      End
      Begin VB.Label Label8 
         Caption         =   "&Topic"
         Height          =   255
         Left            =   2760
         TabIndex        =   26
         Top             =   2310
         Width           =   495
      End
   End
   Begin VB.TextBox txtExtension 
      BackColor       =   &H8000000F&
      ForeColor       =   &H80000007&
      Height          =   315
      Left            =   1020
      Locked          =   -1  'True
      TabIndex        =   1
      ToolTipText     =   "The file extension"
      Top             =   105
      Width           =   795
   End
   Begin VB.Frame frameVerb 
      Caption         =   "Command &verb"
      Height          =   735
      Left            =   60
      TabIndex        =   12
      Top             =   2205
      Width           =   5295
      Begin VB.CommandButton cbMakeDefault 
         Caption         =   "&Make default"
         Height          =   315
         Left            =   3660
         TabIndex        =   16
         ToolTipText     =   "Make the selected Verb be the default. If the verb name is empty the implied default is ""open"""
         Top             =   270
         Width           =   1455
      End
      Begin VB.ComboBox comboVerbs 
         Height          =   315
         Left            =   120
         TabIndex        =   13
         ToolTipText     =   "The selected Action Verb"
         Top             =   270
         Width           =   1635
      End
      Begin VB.CommandButton cbAdd 
         Caption         =   "&Add"
         Height          =   315
         Left            =   1920
         TabIndex        =   14
         ToolTipText     =   "Add the command Verb to the collection"
         Top             =   270
         Width           =   615
      End
      Begin VB.CommandButton cbRemove 
         Caption         =   "&Remove"
         Height          =   315
         Left            =   2640
         TabIndex        =   15
         ToolTipText     =   "Remove the selected Verb"
         Top             =   270
         Width           =   915
      End
   End
   Begin VB.TextBox txtDescription 
      Height          =   315
      Left            =   1020
      TabIndex        =   5
      ToolTipText     =   "The description of the file type (may apply to more than one extension)"
      Top             =   510
      Width           =   3570
   End
   Begin VB.TextBox txtFileClass 
      Height          =   315
      Left            =   2700
      TabIndex        =   3
      ToolTipText     =   "The File Class registry key under which the shell command verbs are found (may apply to more than one extension)"
      Top             =   105
      Width           =   1875
   End
   Begin VB.CommandButton cbOK 
      Cancel          =   -1  'True
      Caption         =   "Cl&ose"
      Default         =   -1  'True
      Height          =   345
      Left            =   4635
      TabIndex        =   28
      ToolTipText     =   "Save the details and close the dialog"
      Top             =   5805
      Width           =   705
   End
   Begin MSComDlg.CommonDialog CommonDialog1 
      Left            =   2160
      Top             =   5670
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   327681
   End
   Begin VB.Image IconFrame 
      Height          =   480
      Left            =   4800
      Top             =   240
      Width           =   480
   End
   Begin VB.Label label20 
      Caption         =   "E&xtension"
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   135
      Width           =   735
   End
   Begin VB.Label Label7 
      Caption         =   "De&scription"
      Height          =   255
      Left            =   120
      TabIndex        =   4
      Top             =   540
      Width           =   795
   End
   Begin VB.Label Label6 
      Caption         =   "File &Class"
      Height          =   255
      Left            =   1905
      TabIndex        =   2
      Top             =   135
      Width           =   735
   End
End
Attribute VB_Name = "frmEditAssociation"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private mChangesMade As Boolean
Private mFileClass As FileClass
Private mAssociation As FileAssociation

'The verb whose commands are currently on display
Private mCurrentVerb As ExecVerb

'Declares for the API calls
Private Declare Function ExtractIcon Lib "shell32.dll" Alias "ExtractIconA" (ByVal hInst As Long, ByVal lpszExeFileName As String, ByVal nIconIndex As Long) As Long
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Private Declare Function CreateWindowEx Lib "user32" Alias "CreateWindowExA" (ByVal dwExStyle As Long, ByVal lpClassName As String, ByVal lpWindowName As String, ByVal dwStyle As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hWndParent As Long, ByVal hMenu As Long, ByVal hInstance As Long, lpParam As Any) As Long
Private Declare Function DestroyWindow Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function GetWindowsDirectory Lib "kernel32" Alias "GetWindowsDirectoryA" (ByVal lpBuffer As String, ByVal nSize As Long) As Long
Private Declare Function DrawIcon Lib "user32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal hIcon As Long) As Long

Private Const SS_ICON = &H3&
Private Const WS_CHILD = &H40000000
Private Const WS_VISIBLE = &H10000000
Private Const STM_SETICON = &H170
Private Const WS_EX_NOPARENTNOTIFY = &H4&

Dim IconIndex As Long 'The icon index. The file name is kept in the text box.
Dim hwndIcon As Long
Dim Edited As Boolean 'Whether the user has edited the icon number
Dim IconCount As Long 'How many icons in the file

'Variables to detect unwanted change events
Private ProgChange As Boolean

Private Sub cbShow_Click()

'Increment the index unless the user edited it or it indicates a resource
If Edited Then
    On Error GoTo Notanumber
    IconIndex = CLng(txtIndex.Text)
ElseIf IconIndex >= 0 Then
    IconIndex = IconIndex + 1
    Call SetChanged
End If

'Wrap around to the first icon
If IconIndex >= IconCount Then IconIndex = 0
Call ShowIcon
txtIndex.Text = CStr(IconIndex)
Edited = False
If IconIndex >= 0 Then cbShow.Caption = "Next &Icon"
Exit Sub

Notanumber:
    MsgBox "The Icon index must be a number", vbExclamation
End Sub
Private Sub SetIconCount()

If txtFile.Text = "" Then
    IconCount = 0
Else
    IconCount = ExtractIcon(App.hInstance, txtFile.Text, -1)
End If
lblIconCount.Caption = CStr(IconCount) & " icons"
txtIndex.Text = CStr(IconIndex)

End Sub

Private Sub ShowIcon()

Dim hIcon As Long

'Either show the icon or clear it
If txtFile.Text <> "" Then
    hIcon = ExtractIcon(App.hInstance, txtFile.Text, IconIndex)
    If hIcon > 2 Then Call SendMessage(hwndIcon, STM_SETICON, hIcon, 0)
End If

Edited = False

End Sub
Public Property Get ChangesMade() As Boolean
    ChangesMade = mChangesMade
End Property
'
'This function must be called just after the form is loaded to initialise
'
Public Sub SetMembers(lAssociation As FileAssociation)
    
'Set the reference to the File association and Class we are editing
Set mAssociation = lAssociation
Set mFileClass = mAssociation.FileClass

'Set the extension. If blank we allow it to be edited
txtExtension.Text = mAssociation.Extension
If mAssociation.Extension = "" Then
  txtExtension.Locked = False
  txtExtension.BackColor = vbWindowBackground
End If

Call ShowClassInformation(mFileClass)
Me.Caption = mAssociation.Extension & " - Edit file association"
mChangesMade = False

End Sub
Private Sub SetChanged()

mChangesMade = True
Me.Caption = mAssociation.Extension & " - Edit file association **Modified**"

End Sub
Private Sub ShowClassInformation(lClass As FileClass)

Dim Index As Integer
Dim lVerb As ExecVerb
    
If lClass Is Nothing Then Exit Sub

'Initialise all the controls
comboVerbs.Clear

ProgChange = True
txtFileClass.Text = lClass.ClassName
txtDescription.Text = lClass.Description

Call SetVerbFrameCaption

For Index = 1 To lClass.VerbCount
  Set lVerb = lClass.Verb(Index)
  comboVerbs.AddItem (lVerb.Verb)
  If Index = 1 Then Call FillTextBoxes(lVerb)
Next

If comboVerbs.ListCount <> 0 Then comboVerbs.ListIndex = 0

IconIndex = lClass.IconIndex
txtFile.Text = lClass.DefaultIconFile
Call SetIconCount
Call ShowIcon
If IconIndex >= 0 Then cbShow.Caption = "Next &Icon"

ProgChange = False

End Sub
Private Sub SetVerbFrameCaption()

    Dim lVerb As ExecVerb
    
    If mFileClass.DefaultVerb = "" Then
        frameVerb.Caption = "Command &verb (no default)"
    Else
        Set lVerb = mFileClass.Verb(mFileClass.DefaultVerb)
        If lVerb Is Nothing Then GoTo NonexistantDefault
        frameVerb.Caption = "Command &verb (default is """ & mFileClass.DefaultVerb & """)"
        GoTo DefaultSet
NonexistantDefault:
        frameVerb.Caption = "Command &verb (DEFAULT """ & mFileClass.DefaultVerb & """ NON-EXISTANT)"
DefaultSet:
    End If
End Sub
'
'A verb has been selected. Fill out the variable text boxes
'
Private Sub FillTextBoxes(lVerb As ExecVerb)

frameCommands.Caption = "Commands for verb """ & lVerb.Verb & """"
txtCommandLine.Text = lVerb.Command

If lVerb.Ddeexec <> "" Then
    txtDDECommand.Text = lVerb.Ddeexec
    txtDDEOnStarting.Text = lVerb.IfExecDde
    txtService.Text = lVerb.Application
    txtTopic.Text = lVerb.Topic
Else
    txtDDECommand.Text = ""
    txtDDEOnStarting.Text = ""
    txtService.Text = ""
    txtTopic.Text = ""
End If


Set mCurrentVerb = lVerb

End Sub
Private Sub SaveAllValues()

mAssociation.Extension = txtExtension.Text
mFileClass.Description = txtDescription.Text
mFileClass.ClassName = txtFileClass.Text

mFileClass.IconIndex = IconIndex
mFileClass.DefaultIconFile = txtFile.Text

If comboVerbs.ListIndex < 0 And comboVerbs.Text <> "" Then
  If MsgBox("The verb in the text box does not exist. Do you want to create it?", vbYesNo) = vbNo Then Exit Sub
  Call cbAdd_Click
End If

Call SaveCommands

End Sub
'
'Add a new verb. The values in the text boxes are the commands for the new verb
'
Private Sub cbAdd_Click()

If Not mFileClass.AddVerb(comboVerbs.Text) Then
  MsgBox mFileClass.LastError
  Exit Sub
End If

Set mCurrentVerb = mFileClass.Verb(comboVerbs.Text)
If mCurrentVerb Is Nothing Then Exit Sub

Call SaveCommands
comboVerbs.AddItem (comboVerbs.Text)
comboVerbs.ListIndex = comboVerbs.NewIndex

Call SetChanged

End Sub
Private Sub cbBrowse_Click()

  CommonDialog1.DialogTitle = "Choose the associated application"
  CommonDialog1.InitDir = App.Path
  CommonDialog1.Filter = "Applications (*.exe)|*.exe|All files (*.*)|*.*"
  CommonDialog1.FilterIndex = 0
  CommonDialog1.CancelError = True
  On Error GoTo UserCancelled
  
  CommonDialog1.ShowOpen
  txtCommandLine.Text = CommonDialog1.FileName
  Call SetChanged

  Exit Sub
  
UserCancelled:
End Sub

Private Sub cbBrowseIcon_Click()

Dim WinDir As String
Dim Length As Long

WinDir = String(256, 0)
Length = GetWindowsDirectory(WinDir, Len(WinDir))
WinDir = Left(WinDir, Length)

  CommonDialog1.DialogTitle = "Choose the file containing the Icon"
  CommonDialog1.InitDir = WinDir
  CommonDialog1.Filter = "Files with icons|*.exe;*.dll;*.ocx;*.ico;*.cur;*.ani|All files (*.*)|*.*"
  CommonDialog1.FilterIndex = 0
  CommonDialog1.CancelError = True
  On Error GoTo UserCancelled
  
  CommonDialog1.ShowOpen
  txtFile.Text = CommonDialog1.FileName
  IconIndex = 0
  txtIndex.Text = CStr(IconIndex)
  Call ShowIcon
  cbShow.Caption = "Next &Icon"
  Call SetChanged

  Exit Sub
  
UserCancelled:
End Sub

Private Sub cbMakeDefault_Click()

Dim TestVerb As ExecVerb

'If the combo box is blank remove the default
If comboVerbs.Text = "" Then
  mFileClass.DefaultVerb = ""
  Call SetVerbFrameCaption
  Exit Sub
End If

'Dont set a default if the text is not an established verb
Set TestVerb = mFileClass(comboVerbs.Text)

If TestVerb Is Nothing Then
  MsgBox "There is no Command Verb of that name"
Else
  mFileClass.DefaultVerb = TestVerb.Verb
  Call SetVerbFrameCaption
  Call SetChanged
End If

End Sub

Private Sub cbOK_Click()
  Unload Me
End Sub

Private Sub cbRemove_Click()

'It is only possible to remove an existing verb
If comboVerbs.ListIndex < 0 Then
  MsgBox "The verb does not exist, choose an exact name from the drop-down list"""
  Exit Sub
End If

If mFileClass.RemoveVerb(comboVerbs.Text) Then
    If mFileClass.VerbCount = 0 Then
        Call comboVerbs.Clear
    Else
        comboVerbs.RemoveItem (comboVerbs.ListIndex)
        comboVerbs.ListIndex = 0
        Call SelectVerb
    End If

    Call SetChanged
Else
    MsgBox mFileClass.LastError
End If

End Sub
'
'Save the contents of the text boxes to the current verb, if there is one
'
Private Sub SaveCommands()

If mCurrentVerb Is Nothing Then Exit Sub

mCurrentVerb.Application = txtService.Text
mCurrentVerb.Command = txtCommandLine.Text
mCurrentVerb.Ddeexec = txtDDECommand.Text
mCurrentVerb.IfExecDde = txtDDEOnStarting.Text
mCurrentVerb.Topic = txtTopic.Text

End Sub
''
'An existing verb has been selected, show its commands
'
Private Sub comboVerbs_Click()

  'Save the commands associated with the current verb
  ProgChange = True
  Call SaveCommands
  Call SelectVerb
  ProgChange = False
  
End Sub
Private Sub SelectVerb()

Dim lVerb As ExecVerb

On Error GoTo NoVerb
Set lVerb = mFileClass.Verb(comboVerbs.Text)
Call FillTextBoxes(lVerb)
Exit Sub

NoVerb:
On Error GoTo 0
End Sub

Private Sub Form_Load()
  
  Set mAssociation = Nothing
  Set mFileClass = Nothing
  Set mCurrentVerb = Nothing
  ProgChange = False

  hwndIcon = CreateWindowEx(WS_EX_NOPARENTNOTIFY, "STATIC", "Test", WS_CHILD Or WS_VISIBLE Or SS_ICON, _
        IconFrame.Left / Screen.TwipsPerPixelX, IconFrame.Top / Screen.TwipsPerPixelY, 32, 32, Me.hwnd, 0, App.hInstance, 0)

End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
    Call SaveAllValues
    Set mAssociation = Nothing
    Set mFileClass = Nothing
    Set mCurrentVerb = Nothing
End Sub

Private Sub txtCommandLine_Change()
    If ProgChange Then Exit Sub
    Call SetChanged
End Sub
Private Sub txtCommandLine_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, x As Single, y As Single)

'Just in case the data is not files
On Error GoTo Exit_Proc
txtCommandLine.Text = Data.Files(1)
Call SetChanged

Exit_Proc:
End Sub

Private Sub txtDDECommand_Change()
    If ProgChange Then Exit Sub
    Call SetChanged
End Sub

Private Sub txtDDEOnStarting_Change()
    If ProgChange Then Exit Sub
    Call SetChanged
End Sub

Private Sub txtDescription_Change()
    If ProgChange Then Exit Sub
    Call SetChanged
End Sub

Private Sub txtExtension_Change()
    If ProgChange Then Exit Sub
    Call SetChanged
End Sub

Private Sub txtFileClass_Change()

Dim lFileClass As FileClass

If ProgChange Then Exit Sub

If txtFileClass.Text <> "" Then
    'Check whether the class exists. If so switch the information
    Set lFileClass = New FileClass
    If lFileClass.LoadFromRegistry(txtFileClass.Text) Then
        Set mFileClass = lFileClass
        Set mAssociation.FileClass = lFileClass
        Call ShowClassInformation(lFileClass)
    End If
End If

Call SetChanged

End Sub
Private Sub txtFile_Change()

Call SetIconCount
Call ShowIcon
    
If ProgChange Then Exit Sub
Call SetChanged

End Sub
Private Sub txtFile_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, x As Single, y As Single)

'Just in case the data is not files
On Error GoTo Exit_Proc
txtFile.Text = Data.Files(1)
Call SetIconCount
IconIndex = 0
txtIndex.Text = CStr(IconIndex)
Call ShowIcon
cbShow.Caption = "Next &Icon"
Call SetChanged

Exit_Proc:
End Sub

Private Sub txtIndex_Change()

If ProgChange Then Exit Sub
Edited = True
cbShow.Caption = "Show &Icon"
Call SetChanged

End Sub

Private Sub txtService_Change()
    If ProgChange Then Exit Sub
    Call SetChanged
End Sub

Private Sub txtTopic_Change()
    If ProgChange Then Exit Sub
    Call SetChanged
End Sub
